
'--------------------------------------------------------------------
' Title       : AMIPASS
' Description : decrypt old (circa 1993) AMI BIOS password from CMOS
' Note        : public domain algorithm found somewhere in alt.2600
' Future      : update to newer AMI BIOS encrypting algorithm ?
'
' Who When     What
' --- -------- ------------------------------------------------------
' PhG 06-01-95 Q&D port from an old PDS7.0 source to PB3.1
'--------------------------------------------------------------------

$CPU 8086

$OPTIMIZE SIZE
$COMPILE EXE

$DEBUG MAP OFF
$DEBUG PBDEBUG OFF

$LIB COM        OFF
$LIB CGA        OFF
$LIB EGA        OFF
$LIB VGA        OFF
$LIB HERC       OFF
$LIB LPT        OFF
$LIB IPRINT     OFF
$LIB FULLFLOAT  OFF

$ERROR BOUNDS   OFF
$ERROR NUMERIC  OFF
$ERROR OVERFLOW OFF
$ERROR STACK    OFF

$FLOAT PROCEDURE

$COM    0
$STRING 16
$STACK  2048
$SOUND  1

$DIM ARRAY

$DYNAMIC
' $STATIC

$OPTION CNTLBREAK OFF

'--------------------------------------------------------------------

DEFINT A-Z
OPTION BINARY BASE 0

%False = 0
%True  = NOT %False

%eNone = 100

%Origin 			= &H37
%MaxPasswordLength 	= 6
%AddressRTC 		= &H70
%ValueRTC 			= &H71

DIM ByteBuffer(0:%MaxPasswordLength + 1)

FOR offset = %Origin TO (%Origin + %MaxPasswordLength)
	OUT %AddressRTC, offset
    ByteBuffer(offset - %Origin) = INP(%ValueRTC)
NEXT
PRINT "Bytes located at offset $37 are :";
FOR i = 0 TO %MaxPasswordLength
  PRINT " $";
  v = ByteBuffer(i)
  IF v < 16 THEN PRINT "0";
  PRINT HEX$(v);
NEXT
PRINT
PRINT

Password$ = ""
ByteBuffer(0) = ByteBuffer(0) AND &B11110000
i = 1
nextround:
IF ByteBuffer(i) = 0 THEN GOTO show
Character = 0
Previous = ByteBuffer(i - 1)
decrypt:
Character = Character + 1
TmpA = 0
TmpB = 0
IF (Previous AND &B10000000) > 0 THEN TmpA = TmpA + 1
IF (Previous AND &B01000000) > 0 THEN TmpA = TmpA + 1
IF (Previous AND &B00000010) > 0 THEN TmpA = TmpA + 1
IF (Previous AND &B00000001) > 0 THEN TmpA = TmpA + 1
plus:
TmpB = TmpB + 2
IF TmpB < TmpA THEN GOTO plus
Previous = Previous \ 2
TmpB = TmpB - TmpA
IF TmpB = 1 THEN Previous = Previous + &B10000000
IF Previous <> ByteBuffer(i) THEN GOTO decrypt
Password$ = Password$ + CHR$(Character)
i = i + 1
IF i < (%MaxPasswordLength + 1) THEN GOTO nextround
show:
IF i = 1 THEN
	PRINT "No password is defined yet!"
ELSE
	PRINT "Current password is "; Password$;
	PRINT " (US keyboard)"
	PRINT
	PRINT "Current Password is ";
	DoubleQuote$ = CHR$(&H22)
	US$ = "`1234567890-="
	US$ = US$ + "qwertyuiop[]"
	US$ = US$ + "asdfghjkl;'\"
	US$ = US$ + "<zxcvbnm,./"
	US$ = US$ + "~!@#$%^&*()_+"
	US$ = US$ + "QWERTYUIOP{}"
	US$ = US$ + "ASDFGHJKL:" + DoubleQuote$ + "|"
	US$ = US$ + ">ZXCVBNM<>?"
	FR$ = "&" + DoubleQuote$ + "'(-_)="
	FR$ = FR$ + "azertyuiop^$"
	FR$ = FR$ + "qsdfghjklm*"
	FR$ = FR$ + "<wxcvbn,;:!"
	FR$ = FR$ + "1234567890+"
	FR$ = FR$ + "AZERTYUIOP"
	FR$ = FR$ + "QSDFGHJKLM%"
	FR$ = FR$ + ">WXCVBN?./"
	FOR i = 1 TO LEN(Password$)
		c$ = MID$(Password$, i, 1)
		p = INSTR(US$, c$)
		c$ = MID$(FR$, p, 1)
		PRINT c$;
	NEXT
	PRINT " (FR keyboard)"
END IF
END %eNone-%eNone

